
-- #######################################
-- #######################################
-- COMBAT LOG EVENT UNFILTERED
-- #######################################
-- #######################################
function GoH.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)

  -- ###########################################################################################################
  -- SINCE THESE ARE LOCAL, YOU CAN RE-USE THE SAME NAMES IN OTHER GOH CLASS MODS AND DON'T HAVE TO CHANGE THEM.
  -- ###########################################################################################################
  local GoH_spellID, GoH_spellName, GoH_all_spellSchool, GoH_amount, GoH_overkill, GoH_school, GoH_resisted, GoH_blocked, GoH_absorbed, GoH_critical = ...

	-- ################################################################
	-- CHECK THE TIMER
	if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == nil then
		GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "YES";
	end
	-- ################################################################

		-- #######################################
		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- #####     BEGIN FINISH IT/HER/HIM MOD     #####
	      -- ###############################################
	      -- ###############################################

	if (sourceName == GoH_DeathKnight.CharName) then -- BEGIN PLAYER SOURCENAME CHECK

		if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Sounds == "YES" then -- BEGIN OPTION CHECK

	      -- ###############################################
	      -- ###############################################

			if (event == "SWING_DAMAGE") or (event == "SPELL_DAMAGE") or (event == "SPELL_PERIODIC_DAMAGE") then -- BEGIN EVENT CHECK SPELL DAMAGE
				if (UnitName("target") ~= nil) then -- BEGIN TARGET NOT NIL CHECK
					if UnitIsDeadOrGhost("target") then -- BEGIN TARGET NOT DEAD CHECK
						-- IF YOUR TARGET IS DEAD OR A GHOST DO NOTHING.
					else -- ELSE TARGET NOT DEAD CHECK
						-- YOUR TARGET MUST STILL BE ALIVE AND NOT A GHOST. and (GoH_overkill < 1)
						if UnitHealth("target") ~= nil then -- BEGIN TARGETHEALTH NIL CHECK
						if ((UnitHealth("target") / UnitHealthMax("target")) <= 0.20) and (GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced == "NO") then -- BEGIN BOOM CHECK
							if ((UnitHealth("target") / UnitHealthMax("target")) >= 0.01) then -- BEGIN TARGET HEALTH CHECK
								if UnitExists("target") and not UnitIsFriend("player", "target") then -- BEGIN NOT A FRIEND EXISTS CHECK
									-- ###############################################
									if (UnitSex("target") == 1) then -- BEGIN GENDER 'IT' CHECK

										-- PLAY 'IT' SOUND
										Play_Combat_Finish_It();

										-- SHOW 'IT' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_It_Frame();
										end

									end -- END GENDER 'IT' CHECK
									-- ###############################################
									-- ###############################################
									if (UnitSex("target") == 2) then -- BEGIN GENDER 'MALE' CHECK

										-- PLAY 'HIM' SOUND
										Play_Combat_Finish_Him();

										-- SHOW 'HIM' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_Him_Frame();
										end

									end -- END GENDER 'MALE' CHECK
									-- ###############################################
									-- ###############################################
									if (UnitSex("target") == 3) then -- BEGIN GENDER 'FEMALE' CHECK

										-- PLAY 'HER' SOUND
										Play_Combat_Finish_Her();

										-- SHOW 'HER' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_Her_Frame();
										end

									end -- ENDGENDER 'FEMALE' CHECK
									-- ###############################################
									-- ###############################################
									-- CHANGE THE ANNOUNCEMENT SAVED VARIABLE SO WE DON'T SPAM IT!

									GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced = "YES";

									-- ###############################################
								end -- END NOT A FRIEND EXISTS CHECK
							end -- END TARGET HEALTH CHECK
						end -- END BOOM CHECK
						end -- END TARGETHEALTH NIL CHECK
					end -- END TARGET NOT DEAD CHECK
				end -- END TARGET NOT NIL CHECK
			end -- END EVENT CHECK SPELL DAMAGE

	      -- ###############################################
	      -- ###############################################

		end -- END OPTION CHECK

	end -- END PLAYER SOURCENAME CHECK

	      -- ###############################################
	      -- ###############################################
	      -- #####      END FINISH IT/HER/HIM MOD      #####
	      -- ###############################################
	      -- ###############################################

		-- #######################################
		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- ##### BEGIN ANNOUNCING CONJURED ITEMS MOD #####
	      -- ###############################################
	      -- ###############################################

				-- RE-CHECK AND SET VARIABLES IF NOT ALREADY SET
				-- GOH SETTING: ANNOUNCE PORTALS
	  			if GoHv5_DeathKnight_Data.config.Announce_Portals == nil then
					GoHv5_DeathKnight_Data.config.Announce_Portals = "NO";
				end
				-- GOH SETTING: ANNOUNCE CONJURED ITEMS
	  			if GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == nil then
					GoHv5_DeathKnight_Data.config.Announce_Conjured_Items = "NO";
				end
				-- GOH SETTING: CONJURE TEMP SPELL
	  			if GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell == nil then
					GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = "BLANK";
				end

	if (GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == "YES") or (GoHv5_DeathKnight_Data.config.Announce_Portals == "YES") then -- BEGIN ANNOUNCE CONJURED ITEMS AND PORTAL CHECK

		-- MESSAGE TYPE?
		msgType = {}
		msgType["pvp"]="BATTLEGROUND"
		msgType["arena"]="PARTY"
		msgType["party"]="PARTY"
		msgType["raid"]="RAID"

	   if (GetNumPartyMembers ~= nil) and (GetNumRaidMembers ~= nil) then -- BEGIN NIL CHECK
		if (GetNumPartyMembers() >= 1) or (GetNumRaidMembers() >= 1) then -- BEGIN PARTY RAID NUMBER CHECK

			if (UnitInParty(sourceName) or UnitInRaid(sourceName)) then -- END PARTY RAID MEMBER CHECK

				-- BEGIN DETECTING CONJURED ITEMS
				if (event == "SPELL_CAST_SUCCESS") or (event == "SPELL_SUMMON") or (event == "SPELL_CAST_START") then -- BEGIN DETECTING CONJURED ITEMS

					if (GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == "YES") then -- BEGIN ANNOUNCE CONJURED ITEMS ONLY CHECK

							-- #######################################

							-- CONJURED: (Mage) Ritual of Refreshment

							if GoH_spellName == Conjure_Ritual_of_Refreshment_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Refreshment_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Warlock) Ritual of Summoning

							if GoH_spellName == Conjure_Ritual_of_Summoning_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Summoning_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end


							-- #######################################
							-- #######################################

							-- CONJURED: (Warlock) Ritual of Souls

							if GoH_spellName == Conjure_Ritual_of_Souls_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Souls_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Alchemy) Cauldron of Battle

							if GoH_spellName == Conjure_Cauldron_of_Battle_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Cauldron_of_Battle_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Alchemy) Big Cauldron of Battle

							if GoH_spellName == Conjure_Big_Cauldron_of_Battle_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Big_Cauldron_of_Battle_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Goblin Barbecue Feast

							if GoH_spellName == Conjure_Goblin_Barbecue_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Goblin_Barbecue_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) moll-e (Mail Box)

							if GoH_spellName == Conjure_moll_e_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_moll_e_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Scrapbot

							if GoH_spellName == Conjure_Scrapbot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Scrapbot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Field Repair Bot 110G

							if GoH_spellName == Conjure_Field_Repair_Bot_110G_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Field_Repair_Bot_110G_Name
							end

							-- #######################################
							-- #######################################
							-- CONJURED: (Engineer) Jeeves

							if GoH_spellName == Conjure_Jeeves_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Jeeves_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Fish Feast

							if GoH_spellName == Conjure_Fish_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Fish_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Great Feast

							if GoH_spellName == Conjure_Great_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Great_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Broiled Dragon Feast

							if GoH_spellName == Conjure_Broiled_Dragon_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Broiled_Dragon_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Seafood Magnifique Feast

							if GoH_spellName == Conjure_Seafood_Magnifique_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Seafood_Magnifique_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Pandaren Banquet

							if GoH_spellName == MoP_Pandaren_Banquet_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Pandaren_Banquet_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Pandaren Banquet

							if GoH_spellName == MoP_Great_Pandaren_Banquet_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Pandaren_Banquet_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Grill

							if GoH_spellName == MoP_Banquet_of_the_Grill_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Grill_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Grill

							if GoH_spellName == MoP_Great_Banquet_of_the_Grill_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Grill_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Oven

							if GoH_spellName == MoP_Banquet_of_the_Oven_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Oven_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Oven

							if GoH_spellName == MoP_Great_Banquet_of_the_Oven_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Oven_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Brew

							if GoH_spellName == MoP_Banquet_of_the_Brew_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Brew_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Brew

							if GoH_spellName == MoP_Great_Banquet_of_the_Brew_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Brew_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Pot

							if GoH_spellName == MoP_Banquet_of_the_Pot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Pot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Pot

							if GoH_spellName == MoP_Great_Banquet_of_the_Pot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Pot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Steamer

							if GoH_spellName == MoP_Banquet_of_the_Steamer_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Steamer_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Steamer

							if GoH_spellName == MoP_Great_Banquet_of_the_Steamer_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Steamer_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Wok

							if GoH_spellName == MoP_Banquet_of_the_Wok_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Wok_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Wok

							if GoH_spellName == MoP_Great_Banquet_of_the_Wok_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Wok_Name
							end

							-- #######################################
							-- #######################################


					end -- END ANNOUNCE CONJURED ITEMS ONLY CHECK
					if (GoHv5_DeathKnight_Data.config.Announce_Portals == "YES") then -- BEGIN ANNOUNCE PORTAL ONLY CHECK

							-- #######################################
							-- #######################################
							  -- MAGE ANCIENT PORTALS: Dalaran

							if GoH_spellID == Conjure_Mage_Ancient_Portal_Dalaran_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Ancient_Portal_Dalaran_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Dalaran

							if GoH_spellID == Conjure_Mage_Portal_Dalaran_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Dalaran_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Darnassus

							if GoH_spellName == Conjure_Mage_Portal_Darnassus_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Darnassus_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Exodar

							if GoH_spellName == Conjure_Mage_Portal_Exodar_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Exodar_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Ironforge

							if GoH_spellName == Conjure_Mage_Portal_Ironforge_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Ironforge_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Orgrimmar

							if GoH_spellName == Conjure_Mage_Portal_Orgrimmar_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Orgrimmar_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Shattrath

							if GoH_spellID == Conjure_Mage_Portal_Shattrath_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Shattrath_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_Shattrath2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Shattrath2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end


							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Silvermoon

							if GoH_spellName == Conjure_Mage_Portal_Silvermoon_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Silvermoon_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Stonard

							if GoH_spellName == Conjure_Mage_Portal_Stonard_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Stonard_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Stormwind

							if GoH_spellName == Conjure_Mage_Portal_Stormwind_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Stormwind_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Theramore

							if GoH_spellName == Conjure_Mage_Portal_Theramore_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Theramore_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Thunderbluff

							if GoH_spellName == Conjure_Mage_Portal_Thunderbluff_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Thunderbluff_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: TolBarad

							if GoH_spellID == Conjure_Mage_Portal_TolBarad_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_TolBarad_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_TolBarad2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_TolBarad2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Undercity

							if GoH_spellName == Conjure_Mage_Portal_Undercity_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Undercity_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Vale of Eternal_Blossoms

							if GoH_spellID == Conjure_Mage_Portal_Vale_of_Eternal_Blossoms_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Vale_of_Eternal_Blossoms_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_Vale_of_Eternal_Blossoms2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Vale_of_Eternal_Blossoms2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							-- #######################################

					end

					-- #######################################
					-- #######################################
					  -- MAIN ANNOUNCER CODE BELOW
					-- #######################################
					-- #######################################

					if GoH_spellName == GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell then -- BEGIN CHECK SPELL DETECTED

							Play_Conjure_Murloc();

							inInstance, instanceType = IsInInstance()

							-- DUNGEON? RAID?
							if inInstance == 1 and instanceType ~= "none" then
								messageType = msgType[instanceType]
							end

							-- CAN DO RAID WARNINGS? IF SO - DO IT
							if (IsRaidOfficer()==1 and instanceType=="raid") then
								messageType = "RAID_WARNING"
							end
							if (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) then
								messageType = "RAID_WARNING"
							end


							-- CAULDRONS SEEM TO ONLY HAVE NOTHING IN 'destName'
							-- SO WE WILL COPY FROM 'spellName'
							-- CAULDRONS ONLY SHOW UP IN 'SPELL_CAST_START'
							if (destName==nil) then
								destName = GoH_spellName
							end

							if (messageType==nil) then -- BEGIN MESSAGE TYPE CHECK

								-- #######################################
								-- #######################################

									-- SPAM TIMER CHECK
									if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then -- BEGIN SPAM CHECK

									-- IF NOT IN A DUNGEON OR RAID INSTANCE ((OUTSIDE)) THEN USE YOUR OWN TICK OPTIONS
									-- HAVEN'T INCLUDED THIS YET...

										-- SOLO ANNOUNCEMENT MAYBE...

										-- RESET THE TIMER
										GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
										-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

									end -- END SPAM CHECK

								-- #######################################
								-- #######################################

							else -- ELSE MESSAGE TYPE CHECK
								-- YOU'RE NOT SOLO

								-- #######################################
								-- #######################################

									-- SPAM TIMER CHECK
									if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then -- BEGIN SPAM CHECK

									-- IF NOT IN A DUNGEON OR RAID INSTANCE ((OUTSIDE)) THEN USE YOUR OWN TICK OPTIONS
									-- HAVEN'T INCLUDED THIS YET...

											-- IF IN A DUNGEON OR RAID INSTANCE ((INSIDE)) THEN USE WHAT IS RETURNED
											AnnouncingMsg = ("{star} " .. sourceName .. " creates " .. destName .." {star}");


											-- SEND THE CHAT MESSAGE
											SendChatMessage(AnnouncingMsg, messageType)


										-- RESET THE TIMER
										GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
										-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

									end -- END SPAM CHECK

								-- #######################################
								-- #######################################

							end -- END MESSAGE TYPE CHECK

					end -- END CHECK SPELL DETECTED

					-- #######################################
					-- #######################################

				end -- END DETECTING CONJURED ITEMS

			end -- END PARTY RAID MEMBER CHECK

		end -- END PARTY RAID NUMBER CHECK
	   end -- END NIL CHECK

	end  -- END ANNOUNCE CONJURED ITEMS AND PORTAL CHECK

		-- #######################################
		-- #######################################

end



-- #######################################
-- #######################################
-- PLAYER ENTER COMBAT
-- #######################################
-- #######################################
function GoH.events.PLAYER_REGEN_DISABLED()

		-- #######################################

		GoH_DND_Combat_Mode_On();

		if GoHv5_DeathKnight_Data.config.Use_Fight_Image == nil then
			GoHv5_DeathKnight_Data.config.Use_Fight_Image = "YES";
		end
		if GoHv5_DeathKnight_Data.config.Use_Fight_Image == "YES" then

			Show_Fight_Frame();

		end

		-- #######################################

end



-- #######################################
-- #######################################
-- PLAYER LEAVE COMBAT
-- #######################################
-- #######################################
function GoH.events.PLAYER_REGEN_ENABLED()

		-- #######################################

			GoH_DND_Combat_Mode_Off();

		-- #######################################
end



-- #######################################
-- #######################################
-- UNIT COMBAT
-- #######################################
-- #######################################
function GoH.events.UNIT_COMBAT(arg1, arg2)

		-- #######################################

			-- BLOCK EVENT
			if (arg1=="player") and (arg2=="BLOCK") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Block == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Block == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Block.mp3","Master");
				end
			end

			-- DODGE EVENT
			if (arg1=="player") and (arg2=="DODGE") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Dodge == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Dodge == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Dodge.mp3","Master");
				end
			end

			-- MISS EVENT
			if (arg1=="player") and (arg2=="MISS") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Miss == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Miss == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Miss.mp3","Master");
				end
			end

			-- PARRY EVENT
			if (arg1=="player") and (arg2=="PARRY") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Parry == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Parry == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Parry.mp3","Master");
				end
			end


		-- #######################################
end


function GoH.events.PLAYER_TARGET_CHANGED()

	-- IF WE ARE USING THE 'FINISH HIM' OPTION, WE NEED TO RESET THE ANNOUNCEMENT ON TARGET CHANGE
	if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Sounds == "YES" then

		-- WE HAVE A NEW TARGET SO RESET THE 'FINISH HIM' ANNOUNCEMENT SAVED VARIABLE
		GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced = "NO";

	end

	-- PLAY SOUND ON TARGET CLICK
	if GoHv5_DeathKnight_Data.config.Use_Target_Sounds == "YES" then

		if (UnitName("target") ~= nil) then
			if (UnitHealth("target") ~= 0) then
				-- TARGET IS ALIVE
				-- Thanks to Shao_Kahn_FTW for this idea
				Play_Random_Alive_Target();
			else
				-- TARGET IS DEAD
				Play_Random_Dead_Target();
			end
		else
		-- PLAY NOTHING IF NO TARGET
		end

	end

end

-- #######################################
-- #######################################
-- PLAYER ENTERING BATTLEGROUND
-- #######################################
-- #######################################
function GoH.events.PLAYER_ENTERING_BATTLEGROUND()

		-- #######################################

		if GoHv5_DeathKnight_Data.config.Play_BattleGround_Sounds == "YES" then

			Play_Random_BattleGround_Sound();

		end

		-- #######################################

end